<?php
// ---------------------------------------------------------------------------
// $Id: TitleAction.class.php,v 1.13 2007-11-29 23:20:49 dankert Exp $
// ---------------------------------------------------------------------------
// OpenRat Content Management System
// Copyright (C) 2002 Jan Dankert, jandankert@jandankert.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------


/**
 * Actionklasse zum Anzeigen der Titelleiste
 * @author $Author: dankert $
 * @version $Revision: 1.13 $
 * @package openrat.actions
 */
class TitleAction extends Action
{
	/**
	 * Standard-Subaction
	 * @type String
	 */
	var $defaultSubAction = 'show';


	/**
	 * Fuellen der Variablen und Anzeigen der Titelleiste
	 */
	function show()
	{
		// Seite ndert sich nur 1x pro Session
		$user = Session::getUser();
//		$this->lastModified( $user->loginDate );
		
		$user = Session::getUser();
//		if	( is_object($user) && isset($user->loginDate) )
//			$this->lastModified( $user->loginDate );

		$this->setTemplateVar('css_body_class','title');

		$db = Session::getDatabase();
//		$this->setTemplateVar('dbid'  ,$db->id              ); 
		$this->setTemplateVar('dbname',$db->conf['comment'] );
//		$this->setTemplateVar('dbdescription',$db->conf['comment'] );

		$user = Session::getUser();		
		$this->setTemplateVar('username'    ,$user->name    );
		$this->setTemplateVar('userfullname',$user->fullname);

		$project = Session::getProject();
		if	( is_object($project) )		
			$this->setTemplateVar('projectname',$project->name);
		
		$language = Session::getProjectLanguage();
		if	( is_object($language) )		
			$this->setTemplateVar('languagename',$language->name);
		
		$model = Session::getProjectModel();
		if	( is_object($model) )		
			$this->setTemplateVar('modelname',$model->name);
		
		// Urls zum Benutzerprofil und zum Abmelden
		$this->setTemplateVar('profile_url',Html::url( 'profile'         ));
		$this->setTemplateVar('logout_url' ,Html::url( 'index','logout'  ));
		
		if	( Session::get('showtree') )
		{
			$this->setTemplateVar('showtree_url' ,Html::url('index','hidetree') );
			$this->setTemplateVar('showtree_text',lang('GLOBAL_HIDETREE')       );
		}
		else
		{
			$this->setTemplateVar('showtree_url' ,Html::url('index','showtree') );
			$this->setTemplateVar('showtree_text',lang('GLOBAL_SHOWTREE')       );
		}
		
		$this->forward( 'title' );
	}
}

?>